function [newsparsebernouliW]=gensparsebernouliW(numberofxt,maxnumberofclusterst,prioralphaforswitcht,priorbetaforswitcht,switchest,Nosubjectsinclustert)
% This function generates the sparse prior parameter
% in accordance with the full conditional distribution of them

nonemptyindicator=Nosubjectsinclustert>-1; 

newsparsebernouliW=zeros(1,numberofxt);

priorprobabforWone=0.5; % prior probability for the W Bernoulli variable

% simple Gibbs updating of the whole vector one by one
for jt=1:numberofxt % for each of the risk factors
    
    if sum(switchest(nonemptyindicator,jt))~=0
        newsparsebernouliW(1,jt)=1;
    else
        
    lognominatorprobforWone=log(gamma(prioralphaforswitcht+priorbetaforswitcht))+...
        +log(gamma(priorbetaforswitcht+sum(nonemptyindicator)))...
        -log(gamma(priorbetaforswitcht))...
        -log(gamma(prioralphaforswitcht+priorbetaforswitcht+sum(nonemptyindicator)));
        
    probforWone=exp(lognominatorprobforWone)*priorprobabforWone;
    
    probforW=probforWone/(probforWone+(1-priorprobabforWone));
    newsparsebernouliW(1,jt)=binornd(1,probforW);
    
    end
    
end
        