 function [newswitches]=genswitches(phitemp,clusteralloct,xt,rhotemp,numberofxt,maxnumberofclusterst,nuoflevelst,switchestemp)
% This function generates the switches 
% in accordance with the full conditional distribution of them

newswitches=switchestemp;

if rand<0.5

% simple Gibbs updating of the whole vector one by one 
for jt=1:numberofxt % for each of the risk factors
if rhotemp(jt)==0
newswitches(:,jt)=zeros(maxnumberofclusterst,1);
else
for ict=1:maxnumberofclusterst % for each of the clusters
    if sum(clusteralloct==ict)>-1 % -1 for all clusters 0 for non-empty clusters
    logprobofzero=log(1-rhotemp(jt)); logprobofone=log(rhotemp(jt));
    for ixt=0:(nuoflevelst(jt)-1) 
        iclustert=ict;
        logprobofone=logprobofone+sum(sum(xt(clusteralloct(:,1)==iclustert,jt)==ixt))*log((phitemp{iclustert,jt}(ixt+1)));
        logprobofzero=logprobofzero+sum(sum(xt(clusteralloct(:,1)==iclustert,jt)==ixt))*log((phitemp{maxnumberofclusterst+1,jt}(ixt+1)));
    end
    logprobofzerooverprobofone=logprobofzero-logprobofone;
    probofone=1/(exp(logprobofzerooverprobofone)+1);
    newswitches(ict,jt)=binornd(1,probofone);
    else
        newswitches(ict,jt)=0;
    end
end
end
end

else

%metropolis step for the updating of the switches vector (Tadesse et al. 2005)
%note: the switches are conditionally independent
for jt=1:numberofxt % for each of the risk factors
    if rhotemp(jt)==0
    newswitches(:,jt)=zeros(maxnumberofclusterst,1);
    end
end

for ict=1:maxnumberofclusterst % for each of the clusters
if sum(clusteralloct==ict)>-1 % -1 for all clusters 0 for non-empty clusters
if rand<1/2 || sum(sum(switchestemp(ict,:)))==0 || sum(sum(switchestemp(ict,:)))==numberofxt % choose one switch and try to change it
    position=unidrnd(numberofxt);
    if rhotemp(position)~=0
    logprobofzero=log(1-rhotemp(position)); logprobofone=log(rhotemp(position));
    for ixt=0:(nuoflevelst(position)-1) 
        iclustert=ict;
        logprobofone=logprobofone+sum(sum(xt(clusteralloct(:,1)==iclustert,position)==ixt))*log((phitemp{iclustert,position}(ixt+1)));
        logprobofzero=logprobofzero+sum(sum(xt(clusteralloct(:,1)==iclustert,position)==ixt))*log((phitemp{maxnumberofclusterst+1,position}(ixt+1)));
    end   
    logprobofzerooverprobofone=logprobofzero-logprobofone;
    probofone=1/(exp(logprobofzerooverprobofone)+1);
    acc_prob_s=abs((switchestemp(ict,position)-probofone)/(1-switchestemp(ict,position)-probofone));
    rand2=rand<acc_prob_s;
    newswitches(ict,position)=rand2*abs(1-switchestemp(ict,position))+(1-rand2)*switchestemp(ict,position);
    if rhotemp(position)==0; newswitches(ict,position)=0; end
    end
else % choose a zero and an one and swap their values 
    position2=[1;1]; while switchestemp(ict,position2(1))==switchestemp(ict,position2(2)); position2=unidrnd(numberofxt,2,1); end
    if (rhotemp(position2(1))~=0 && rhotemp(position2(2))~=0)
    logprobofzero2=log([1-rhotemp(position2(1));1-rhotemp(position2(2))]); logprobofone2=log([rhotemp(position2(1));rhotemp(position2(2))]);
    for ixt=0:nuoflevelst(position2(1))-1 
        iclustert=ict;
        logprobofone2(1)=logprobofone2(1)+sum(sum(xt(clusteralloct(:,1)==iclustert,position2(1))==ixt))*log((phitemp{iclustert,position2(1)}(ixt+1)));
        logprobofzero2(1)=logprobofzero2(1)+sum(sum(xt(clusteralloct(:,1)==iclustert,position2(1))==ixt))*log((phitemp{maxnumberofclusterst+1,position2(1)}(ixt+1)));
    end  
    for ixt=0:nuoflevelst(position2(2))-1 
        iclustert=ict;
        logprobofone2(2)=logprobofone2(2)+sum(sum(xt(clusteralloct(:,1)==iclustert,position2(2))==ixt))*log((phitemp{iclustert,position2(2)}(ixt+1)));
        logprobofzero2(2)=logprobofzero2(2)+sum(sum(xt(clusteralloct(:,1)==iclustert,position2(2))==ixt))*log((phitemp{maxnumberofclusterst+1,position2(2)}(ixt+1)));
    end  
    logprobofzerooverprobofone2(1)=logprobofzero2(1)-logprobofone2(1);
    logprobofzerooverprobofone2(2)=logprobofzero2(2)-logprobofone2(2);
    probofone2(1)=1/(exp(logprobofzerooverprobofone2(1))+1);
    probofone2(2)=1/(exp(logprobofzerooverprobofone2(2))+1);
    acc_prob_s=abs((switchestemp(ict,position2(1))-probofone2(1))*(switchestemp(ict,position2(2))-probofone2(2))/((1-switchestemp(ict,position2(1))-probofone2(1))*(1-switchestemp(ict,position2(2))-probofone2(2))));
    rand2=rand<acc_prob_s;
    newswitches(ict,position2(1))=rand2*abs(1-switchestemp(ict,position2(1)))+(1-rand2)*switchestemp(ict,position2(1));
    newswitches(ict,position2(2))=rand2*abs(1-switchestemp(ict,position2(2)))+(1-rand2)*switchestemp(ict,position2(2));
    if rhotemp(position2(1))==0; newswitches(ict,position2(1))=0; end
    if rhotemp(position2(2))==0; newswitches(ict,position2(1))=0; end
    end
end
else
        newswitches(ict,:)=zeros(1,numberofxt);
end

end

end