function [psicf,psicdif,phif,phidif,thetaf]=...
    reproduceparam6logistic(nuoflevelst,vectorofxt,averageyt,averagext,clusterallocfinal,clusteralloctemp,riskthetatemp,psictemp,phitemp,itertemp,maxnumofclustemp)

% THIS FUNCTION REPRODUCES THE MODEL PARAMETERS, ACCOUNTING FOR UNCERTAINTY, 
% AFTER A FINAL CLUSTERING HAS BEEN SELECTED

psicf=zeros(itertemp,maxnumofclustemp);
psicdif=zeros(itertemp,maxnumofclustemp);
thetaf=zeros(itertemp,maxnumofclustemp);
phif=zeros(itertemp,size([phitemp{1,1,:}],2),maxnumofclustemp);
phidif=zeros(itertemp,size([phitemp{1,1,:}],2),maxnumofclustemp);
gooddispphi0=cell(1,maxnumofclustemp);
gooddispphi=cell(1,maxnumofclustemp);
gooddispphi2=cell(1,maxnumofclustemp);

funcaverage=@mean;
funcaverage2=@mean;

for i=1:itertemp
    dividewith=0; clustersizevector=[]; %non simple sum to zero
   for icluster=1:maxnumofclustemp % this refers to the clusters of the final clustering
       if sum(clusterallocfinal==icluster)>0
        dividewith=dividewith+1; 
        clustersizevector=[clustersizevector sum(clusterallocfinal==icluster)]; %non simple sum to zero
        psicf(i,icluster)=mean(psictemp(i,clusteralloctemp(i,clusterallocfinal==icluster)));
        psicdif(i,icluster)=mean(psictemp(i,clusteralloctemp(i,clusterallocfinal==icluster)))...
            -mean(psictemp(i,clusteralloctemp(i,:)));
        thetaf(i,icluster)=funcaverage(riskthetatemp(i,clusteralloctemp(i,clusterallocfinal==icluster))); 
        phitemp2=zeros(1,size([phitemp{1,icluster,:}],2));
        phitemp2mean=zeros(1,size([phitemp{1,icluster,:}],2));
        for icluster2=1:maxnumofclustemp % this for the clusters in each iteration
            phitemp1=[phitemp{i,icluster2,:}]; % creates a vector with the elements of phisave{itemp,ictemp,:}
            phitemp2=phitemp2+sum(clusteralloctemp(i,clusterallocfinal==icluster)==icluster2)*phitemp1;
            phitemp2mean=phitemp2mean+sum(clusteralloctemp(i,:)==icluster2)*phitemp1;
        end
        phif(i,:,icluster)=phitemp2/sum(clusterallocfinal==icluster);
        phidif(i,:,icluster)=(phitemp2/sum(clusterallocfinal==icluster))...
            -(phitemp2mean/size(clusterallocfinal,2));
       end
   end
   %thetaf(i,:)=thetaf(i,:)-(sum(thetaf(i,:))/dividewith); % simple sum to zero
   thetaf(i,:)=thetaf(i,:)-(((clustersizevector*(thetaf(i,1:dividewith)')))/size(clusterallocfinal,2)); % weighted sum to zero
end

% *********************************************************************
% This is for displaying the actual densities and CIs of the parameters
% and their significance w.r.t. the population averages
% *********************************************************************
% *********************************************************************
% This is for the densities of the difference between a theta or phi and
%         the average of the corresponding phi ot theta in the iteration
% It presents if the above densities are 'significant' w.r.t. zero
%     NOTE: Positive difference means parameter (risk )greater than average
% *********************************************************************

for icluster=1:maxnumofclustemp %calculations and rough display of phis
    gooddispphi0{icluster}='';
    if sum(clusterallocfinal==icluster)>1
    dispphi=funcaverage2(phif(:,:,icluster),1); 
    disp(['Av. phis for cl. ' num2str(icluster) ' = ' num2str(dispphi)]); 
    disp('CIs:')
    for iii=1:size(phitemp2,2)
        tempsortphi=sort(phif(:,iii,icluster)); % for the CI's
        if averagext(iii)<tempsortphi(round(itertemp*2.5/100))
        gooddispphi0{icluster}=[gooddispphi0{icluster} '>'];
        disp([' (' num2str(tempsortphi(round(itertemp*2.5/100))) ',' num2str(tempsortphi(round(itertemp*97.5/100))) ') **>'])
        elseif averagext(iii)>tempsortphi(round(itertemp*97.5/100))
        gooddispphi0{icluster}=[gooddispphi0{icluster} '<'];
        disp([' (' num2str(tempsortphi(round(itertemp*2.5/100))) ',' num2str(tempsortphi(round(itertemp*97.5/100))) ') **<'])
        else
        gooddispphi0{icluster}=[gooddispphi0{icluster} '0'];
        disp([' (' num2str(tempsortphi(round(itertemp*2.5/100))) ',' num2str(tempsortphi(round(itertemp*97.5/100))) ') '])
        end
    end
    end
end

for icluster=1:maxnumofclustemp %calculations and rough display for differences of phis
    gooddispphi{icluster}='';
    if sum(clusterallocfinal==icluster)>1
    dispphi=funcaverage2(phidif(:,:,icluster),1); 
    disp(['Av. phidifs for cl. ' num2str(icluster) ' = ' num2str(dispphi)]); 
    disp('CIs:')
    for iii=1:size(phitemp2,2)
        tempsortphi=sort(phidif(:,iii,icluster)); % for the CI's
        if 0<tempsortphi(round(itertemp*2.5/100))
        gooddispphi{icluster}=[gooddispphi{icluster} '>'];
        disp([' (' num2str(tempsortphi(round(itertemp*2.5/100))) ',' num2str(tempsortphi(round(itertemp*97.5/100))) ') **>'])
        elseif 0>tempsortphi(round(itertemp*97.5/100))
        gooddispphi{icluster}=[gooddispphi{icluster} '<'];
        disp([' (' num2str(tempsortphi(round(itertemp*2.5/100))) ',' num2str(tempsortphi(round(itertemp*97.5/100))) ') **<'])
        else
        gooddispphi{icluster}=[gooddispphi{icluster} '0'];
        disp([' (' num2str(tempsortphi(round(itertemp*2.5/100))) ',' num2str(tempsortphi(round(itertemp*97.5/100))) ') '])
        end
    end
    end
end

for icluster=1:maxnumofclustemp % for displaying cluster info
    if sum(clusterallocfinal==icluster)>1
    tempsorttheta=sort(thetaf(:,icluster));
    probgreaterzero=sum(tempsorttheta>0)/itertemp;
    if 0<tempsorttheta(round(itertemp*2.5/100)) 
    disp(['Average risk for cluster ' num2str(icluster) ' = ' num2str(funcaverage(thetaf(:,icluster)))...
        ' CI = (' num2str(tempsorttheta(round(itertemp*2.5/100))) ',' num2str(tempsorttheta(round(itertemp*97.5/100)))...
        '), No of subj.=' num2str(sum(clusterallocfinal==icluster)) ' **>  ' gooddispphi0{icluster}...
        ' probgreaterzero= ' num2str(probgreaterzero)]);
    elseif 0>tempsorttheta(round(itertemp*97.5/100))
    disp(['Average risk for cluster ' num2str(icluster) ' = ' num2str(funcaverage(thetaf(:,icluster)))...
        ' CI = (' num2str(tempsorttheta(round(itertemp*2.5/100))) ',' num2str(tempsorttheta(round(itertemp*97.5/100)))...
        '), No of subj.=' num2str(sum(clusterallocfinal==icluster)) ' **<  ' gooddispphi0{icluster}...
        ' probgreaterzero= ' num2str(probgreaterzero)]);
    else
    disp(['Average risk for cluster ' num2str(icluster) ' = ' num2str(funcaverage(thetaf(:,icluster)))...
        ' CI = (' num2str(tempsorttheta(round(itertemp*2.5/100))) ',' num2str(tempsorttheta(round(itertemp*97.5/100)))...
        '), No of subj.=' num2str(sum(clusterallocfinal==icluster)) '    ' gooddispphi0{icluster}...
        ' probgreaterzero= ' num2str(probgreaterzero)]);
    end
    end
end

disp(vectorofxt'); % for disp factor/phi info for each cluster
for icluster=1:maxnumofclustemp 
    if sum(clusterallocfinal==icluster)>1
        gooddispphi2{icluster}=['  ' gooddispphi{icluster}(1:nuoflevelst(1))];
        for idisp=1:size(nuoflevelst,2)-1
            gooddispphi2{icluster}=[gooddispphi2{icluster} '     ' gooddispphi{icluster}(sum(nuoflevelst(1:idisp))+1:sum(nuoflevelst(1:idisp+1)))];
        end
        disp(['Clust ' num2str(icluster) ' : ' gooddispphi2{icluster}]);
    end
end


