function [newsparsebernouliW]=gensparsebernouliW(phitemp,clusteralloct,xt,numberofxt,maxnumberofclusterst,nuoflevelst,averagext,prioralphaforswitcht,priorbetaforswitcht,switchest)
% This function generates the sparse prior parameter
% in accordance with the full conditional distribution of them

newsparsebernouliW=zeros(1,numberofxt);

priorprobabforWone=0.5; % prior probability for the W Bernoulli variable

% simple Gibbs updating of the whole vector one by one
for jt=1:numberofxt % for each of the risk factors
    
    logyf=0;
    for ixt=0:(nuoflevelst(jt)-1) 
     for iclustert=1:maxnumberofclusterst
     logyf=logyf+sum(sum(xt(clusteralloct(:,1)==iclustert,jt)==ixt))*...
       log(0*(phitemp{iclustert,jt}(ixt+1)-averagext(1,sum(nuoflevelst(1,1:jt-1))+ixt+1))+averagext(1,sum(nuoflevelst(1,1:jt-1))+ixt+1));
     end
    end  
    logprobforWzero=(logyf)+log(1-priorprobabforWone);
    
    Zforintegration=0.01:0.01:0.99;
    logyf=0*ones(1,size(Zforintegration,2));
    for ixt=0:(nuoflevelst(jt)-1) 
     for iclustert=1:maxnumberofclusterst
        logyf=logyf+(sum(sum(xt(clusteralloct(:,1)==iclustert,jt)==ixt))*ones(1,size(Zforintegration,2))).*...
        log(Zforintegration.*((phitemp{iclustert,jt}(ixt+1)-averagext(1,sum(nuoflevelst(1,1:jt-1))+ixt+1))*ones(1,size(Zforintegration,2)))+...
        (averagext(1,sum(nuoflevelst(1,1:jt-1))+ixt+1)*ones(1,size(Zforintegration,2))));  
     end
    end 
    
    logyf=logyf+(log(betapdf(Zforintegration,prioralphaforswitcht,priorbetaforswitcht)));  
    templogyf=(logyf)-mean(logyf);
    logintresult=log(trapz(Zforintegration,exp(templogyf)))+mean(logyf);
     logprobforWone=logintresult+log(priorprobabforWone);
        
        
    probforW=1/(1+exp(logprobforWzero-logprobforWone));
    newsparsebernouliW(1,jt)=binornd(1,probforW);
end
        