function [clustermatrixsave,clusterallocselectind,riskthetasave,clusterallocsave,psicsave,phisave,phisavestar,switchessave,alphaforpsisave,sparsebernouliWsave]...
    =mainnointlatentswitchesarand(y,x,nuoflevels,burnin,iter,thin,somemodelparams,indicateordinal,averagex)
% THIS FUNCTION IMPLEMENTS THE MODEL IN VARIABLES SELECTION MANUSCRIPT
% WITH LATENT SELECTION WEIGHTS
% y is the response. x is the explanatory factors
% Gibbs sampling is employed 
% ALSO TAKES INTO ACCOUNT MISSING X'S

% Assume that, in the data set, the levels of each factor are denoted
% as 0,1,2,3,...
% vector nuoflevels contains the number of levels of each covariate Xj

sizey=size(y,1); % the number of subjects 
numberofx=size(x,2); % number of covariates
[missingx,wheremissingx]=checkformissingx(x); %checks for missing x. Returns
      % logical 0/1 and logical 0/1 indicator where the missing values are
maxnumberofclusters=somemodelparams(1);        
% *************************************************************
% preallocating memory 
% *************************************************************
indyincluster=cell(1,maxnumberofclusters);
betaphi=cell(1,size(x,2));
ncjx=cell(maxnumberofclusters,size(x,2)); % +1 for the phis for when the switch is zero
phi=cell(maxnumberofclusters,size(x,2)); % +1 for the phis for when the switch is zero
phistar=cell(maxnumberofclusters,size(x,2)); % +1 for when the switch is zero
gammathres=cell(maxnumberofclusters,sum(indicateordinal)); % +1 for the phis for when the switch is zero
psicsave=zeros(iter,maxnumberofclusters);
phisave=cell(iter,maxnumberofclusters,size(x,2));
phisavestar=cell(iter,maxnumberofclusters,size(x,2));
Nosubjectsincluster=zeros(1,maxnumberofclusters);% num of subjects per cluster
Noyonesincluster=zeros(1,maxnumberofclusters); % num of y's =1 in each cluster
clustermatrixsave=zeros(sizey,sizey); 
riskthetasave=zeros(iter,maxnumberofclusters);
clusterallocsave=zeros(iter,sizey);
acc_prob_counter=0; % for the metropolis part for the thresholds
switchessave=zeros(iter,numberofx);
alphaforpsisave=zeros(iter,1); leftbound=somemodelparams(2); rightbound=somemodelparams(3);
prioralphaforswitch=somemodelparams(4); priorbetaforswitch=somemodelparams(5); 
sparsebernouliWsave=zeros(iter,numberofx); 

% *************************************************************
% intitial values for the model parameters
% *************************************************************

switches=unifrnd(0,1,1,numberofx);
sparsebernouliW=ones(1,numberofx);

fixedprofileequalityvector=zeros(size(y,1),1); %generate vector with equal elements for subjects with equal profiles
indexplusone=0;
for ist=1:size(y,1) % subject loop
    if (fixedprofileequalityvector(ist,1)==0 && sum(x(ist,:)==-999)==0)
        fixedprofileequalityvector=fixedprofileequalityvector+ismember([y x],[y(ist,1) x(ist,:)],'rows')*(1+indexplusone); 
        indexplusone=indexplusone+1;
    end
end
fixedwheremissingsubj=find(fixedprofileequalityvector==0); % vector that shows the subjects where we have missing x's
profileequalityvector=fixedprofileequalityvector;

if (missingx) % generate missing x values
    for jt=1:size(x,2)
        if sum(wheremissingx(:,jt))>0
            x(wheremissingx(:,jt),jt)=round(mean(x(~wheremissingx(:,jt),jt)));
        end
    end
end

clusteralloc=unidrnd(5,sizey,1);
for ic=1:maxnumberofclusters
    indyincluster{ic}=clusteralloc==ic; % vector with ones for y in cluster ic
    Nosubjectsincluster(1,ic)=sum(indyincluster{ic});
    Noyonesincluster(1,ic)=sum(y(indyincluster{ic}));
end
thetarisk=genthetaparam(Nosubjectsincluster,Noyonesincluster);

alphaforpsi=somemodelparams(6); % for the stick breaking prior 

for ic=1:maxnumberofclusters % phi values for the different clusters. 
    for j=1:numberofx
        if indicateordinal(j)==0 % if X is NOT ordinal
            betaphi{j}=0.5*ones(1,nuoflevels(j)); %prior for phiclusterj
            phi{ic,j}=genphi_latent(ic,j,clusteralloc,x,nuoflevels,averagex,switches,betaphi{j});
        end
    end
end

if (missingx) % generate missing x values
    x=genmissingx(x,wheremissingx,clusteralloc,phi); % generate missing x values
    % 
    profileequalityvector=fixedprofileequalityvector; % generate profileequalityvector
    wheremissingsubj=fixedwheremissingsubj;
    while sum(profileequalityvector==0)>0
        tempvector=ismember([y x],[y(wheremissingsubj(1,1),1) x(wheremissingsubj(1,1),:)],'rows');
        if sum(profileequalityvector(tempvector))>0
            profileequalityvector(tempvector)=max(profileequalityvector(tempvector));
            wheremissingsubj=find(profileequalityvector==0);
        else
            profileequalityvector(tempvector)=max(profileequalityvector)+1; 
            wheremissingsubj=find(profileequalityvector==0);
        end
    end
end

% *******************************************************************
% main sampling loop
% *******************************************************************
for i=2:(burnin+thin*iter)
    i
    % update the cluster parameters (psi's)
    vforpsi=genvforpsi(Nosubjectsincluster,alphaforpsi); vforpsi=vforpsi(1:(maxnumberofclusters-1));
    psic=vforpsi;
    tempforpsi=ones(1,maxnumberofclusters-1)-vforpsi;
    for ipsi=2:maxnumberofclusters-1
        psic(ipsi)=psic(ipsi)*prod(tempforpsi(1,1:ipsi-1));
    end
    psic(maxnumberofclusters)=prod(tempforpsi(1,1:maxnumberofclusters-1));
    
    %update the cluster parameters (phi's) assuming all covar. are needed
    for ic=1:maxnumberofclusters
    for j=1:numberofx
        if indicateordinal(j)==0 % if X is NOT ordinal
            betaphi{j}=0.5*ones(1,nuoflevels(j)); %prior for phiclusterj
            phi{ic,j}=genphi_latent(ic,j,clusteralloc,x,nuoflevels,averagex,switches,betaphi{j});
            phistar{ic,j}=phi{ic,j}.*(switches(1,j)*ones(1,nuoflevels(j)))+...
                averagex(1,(sum(nuoflevels(1,1:j-1))+1):sum(nuoflevels(1,1:j))).*((1-switches(1,j))*ones(1,nuoflevels(j)));
        end
    end
    end
    
    % update cluster allocations and generate vector with num of subjects
    % per cluster and vector with number of ones in each cluster
    [clusteralloc,Nosubjectsincluster,Noyonesincluster]...
        =genclusteralloc(y,x,psic,phistar,clusteralloc,Nosubjectsincluster,Noyonesincluster,thetarisk,profileequalityvector);
    
    if (missingx) % generate missing x values
        x=genmissingx(x,wheremissingx,clusteralloc,phi); 
        % 
        profileequalityvector=fixedprofileequalityvector; % generate profileequalityvector
        wheremissingsubj=fixedwheremissingsubj;
        while sum(profileequalityvector==0)>0
            tempvector=ismember([y x],[y(wheremissingsubj(1,1),1) x(wheremissingsubj(1,1),:)],'rows');
            if sum(profileequalityvector(tempvector))>0
                profileequalityvector(tempvector)=max(profileequalityvector(tempvector));
                wheremissingsubj=find(profileequalityvector==0);
            else
                profileequalityvector(tempvector)=max(profileequalityvector)+1; 
                wheremissingsubj=find(profileequalityvector==0);
            end
        end
    end
    
    % generate the theta parameters
    thetarisk=genthetaparam(Nosubjectsincluster,Noyonesincluster);
   
    % generate the switch parameters
    switches=genswitches(phi,clusteralloc,x,numberofx,maxnumberofclusters,nuoflevels,averagex,prioralphaforswitch,priorbetaforswitch,sparsebernouliW,switches);
    
    % generate the sparsebernouliW parameter
    sparsebernouliW=gensparsebernouliW(phi,clusteralloc,x,numberofx,maxnumberofclusters,nuoflevels,averagex,prioralphaforswitch,priorbetaforswitch,switches);
    
    % generate the alphaforpsi parameter
    alphaforpsi=genalphaforpsi(vforpsi,leftbound,rightbound);
    
     if i>burnin && mod(i-burnin,thin)==0
         psicsave((i-burnin)/thin,:)=psic;
         clusterallocsave((i-burnin)/thin,:)=clusteralloc;
         for ic=1:maxnumberofclusters
             ind=clusteralloc==ic;
             clustermatrixsave(ind,ind)=clustermatrixsave(ind,ind)+1;
             for j=1:numberofx
                    phisave{(i-burnin)/thin,ic,j}=phi{ic,j};
                    phisavestar{(i-burnin)/thin,ic,j}=phistar{ic,j};
             end
         end
         riskthetasave((i-burnin)/thin,:)=thetarisk;
         switchessave((i-burnin)/thin,:)=switches;
         alphaforpsisave((i-burnin)/thin,1)=alphaforpsi;
         sparsebernouliWsave((i-burnin)/thin,:)=sparsebernouliW;
     end
    
end

disp(acc_prob_counter/((thin*iter+burnin)*maxnumberofclusters*sum(indicateordinal)));

clustermatrixsave=clustermatrixsave/iter;

% ***************************************************************
% selecting a clustering (least squares method)
% ***************************************************************
clusterselect=zeros(sizey,sizey);
for ic=1:maxnumberofclusters % first selected clustering
    ind=clusterallocsave(1,:)==ic;
    clusterselect(ind,ind)=clusterselect(ind,ind)+1;
end
clusterallocselectind=1;
for i=2:iter %loop for selecting a certain cluster
    clusterpossible=zeros(sizey,sizey);
    for ic=1:maxnumberofclusters 
        ind=clusterallocsave(i,:)==ic;
        clusterpossible(ind,ind)=clusterpossible(ind,ind)+1;
    end
    if sum(sum((clusterpossible-clustermatrixsave).^2))<sum(sum((clusterselect-clustermatrixsave).^2))
        clusterselect=clusterpossible; clusterallocselectind=i;
    end
end